/**
 * 
 */
package de.bstly.board.model;

import java.time.Instant;


/**
 * The Interface RankedEntry.
 */
public interface RankedEntry {

	/**
	 * Gets the id.
	 *
	 * @return the id
	 */
	Long getId();

	/**
	 * Gets the author.
	 *
	 * @return the author
	 */
	String getAuthor();

	/**
	 * Gets the created.
	 *
	 * @return the created
	 */
	Instant getCreated();

	/**
	 * Gets the entry type.
	 *
	 * @return the entry type
	 */
	EntryType getEntry_Type();

	/**
	 * Gets the url.
	 *
	 * @return the url
	 */
	String getUrl();

	/**
	 * Gets the title.
	 *
	 * @return the title
	 */
	String getTitle();

	/**
	 * Gets the text.
	 *
	 * @return the text
	 */
	String getText();

	/**
	 * Gets the ranking.
	 *
	 * @return the ranking
	 */
	Double getRanking();

	/**
	 * Gets the points.
	 *
	 * @return the points
	 */
	Long getPoints();
}
